"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactNativeImagePanZoom = _interopRequireDefault(require("react-native-image-pan-zoom"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var window = _reactNative.Dimensions.get('window');

var w = window.width;
var h = window.height;

var ImageCropper =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(ImageCropper, _PureComponent);

  function ImageCropper() {
    var _this;

    _classCallCheck(this, ImageCropper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ImageCropper).call(this));
    _this.state = {
      positionX: 0,
      positionY: 0,
      width: 0,
      height: 0,
      minScale: 1.01,
      adjustedHeight: 0,
      loading: true
    };

    _this.handleMove = function (_ref) {
      var positionX = _ref.positionX,
          positionY = _ref.positionY,
          scale = _ref.scale;
      var setCropperParams = _this.props.setCropperParams;

      _this.setState(function (prevState) {
        return _objectSpread({}, prevState, {
          positionX: positionX,
          positionY: positionY,
          scale: scale
        });
      }, function () {
        return setCropperParams(_this.state);
      });
    };

    _this.imageZoom = _react.default.createRef();
    return _this;
  }

  _createClass(ImageCropper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var imageUri = this.props.imageUri;

      _reactNative.Image.getSize(imageUri, function (width, height) {
        var setCropperParams = _this2.props.setCropperParams;
        var srcSize = {
          w: width,
          h: height
        };
        var fittedSize = {
          w: 0,
          h: 0
        };
        var scale = 1.01;
        var screenSize = {
          w: w,
          h: h
        };

        if (width > height) {
          var ratio = w / height;
          fittedSize.w = width * ratio;
          fittedSize.h = w;
        } else if (width < height) {
          var _ratio = w / width;

          fittedSize.w = w;
          fittedSize.h = height * _ratio;
        } else if (width === height) {
          scale = 1;
          fittedSize.w = w;
          fittedSize.h = w;
        }

        _this2.setState(function (prevState) {
          return _objectSpread({}, prevState, {
            screenSize: screenSize,
            srcSize: srcSize,
            fittedSize: fittedSize,
            minScale: scale,
            loading: false
          });
        }, function () {
          _this2.imageZoom.current.centerOn({
            x: 0,
            y: 0,
            scale: scale,
            duration: 0
          });

          setCropperParams(_this2.state);
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          loading = _this$state.loading,
          fittedSize = _this$state.fittedSize,
          minScale = _this$state.minScale;

      var _this$props = this.props,
          imageUri = _this$props.imageUri,
          restProps = _objectWithoutProperties(_this$props, ["imageUri"]);

      var imageSrc = {
        uri: imageUri
      };
      return !loading ? _react.default.createElement(_reactNativeImagePanZoom.default, _extends({
        ref: this.imageZoom
      }, restProps, {
        cropWidth: w,
        cropHeight: w,
        imageWidth: fittedSize.w,
        imageHeight: fittedSize.h,
        minScale: minScale,
        onMove: this.handleMove
      }), _react.default.createElement(_reactNative.Image, {
        style: {
          width: fittedSize.w,
          height: fittedSize.h
        },
        source: imageSrc
      })) : null;
    }
  }]);

  return ImageCropper;
}(_react.PureComponent);

ImageCropper.propTypes = {
  imageUri: _propTypes.default.string.isRequired,
  setCropperParams: _propTypes.default.func.isRequired
};
var _default = ImageCropper;
exports.default = _default;