"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNative = require("react-native");

var _percentCalculator = require("../helpers/percentCalculator");

var _default = function _default(params) {
  var imageUri = params.imageUri,
      cropSize = params.cropSize,
      positionX = params.positionX,
      positionY = params.positionY,
      screenSize = params.screenSize,
      srcSize = params.srcSize,
      fittedSize = params.fittedSize,
      scale = params.scale;
  var offset = {
    x: 0,
    y: 0
  };
  var wScale = screenSize.w / scale;
  var percentCropperAreaW = (0, _percentCalculator.getPercentDiffNumberFromNumber)(wScale, fittedSize.w);
  var percentRestW = 100 - percentCropperAreaW;
  var hiddenAreaW = (0, _percentCalculator.getPercentFromNumber)(percentRestW, fittedSize.w);
  var percentCropperAreaH = (0, _percentCalculator.getPercentDiffNumberFromNumber)(wScale, fittedSize.h);
  var percentRestH = 100 - percentCropperAreaH;
  var hiddenAreaH = (0, _percentCalculator.getPercentFromNumber)(percentRestH, fittedSize.h);
  var x = hiddenAreaW / 2 - positionX;
  var y = hiddenAreaH / 2 - positionY;
  offset.x = x <= 0 ? 0 : x;
  offset.y = y <= 0 ? 0 : y;
  var srcPercentCropperAreaW = (0, _percentCalculator.getPercentDiffNumberFromNumber)(offset.x, fittedSize.w);
  var srcPercentCropperAreaH = (0, _percentCalculator.getPercentDiffNumberFromNumber)(offset.y, fittedSize.h);
  var offsetW = (0, _percentCalculator.getPercentFromNumber)(srcPercentCropperAreaW, srcSize.w);
  var offsetH = (0, _percentCalculator.getPercentFromNumber)(srcPercentCropperAreaH, srcSize.h);
  var sizeW = (0, _percentCalculator.getPercentFromNumber)(percentCropperAreaW, srcSize.w);
  var sizeH = (0, _percentCalculator.getPercentFromNumber)(percentCropperAreaH, srcSize.h);
  offset.x = offsetW;
  offset.y = offsetH;
  var cropData = {
    offset: offset,
    size: {
      width: sizeW,
      height: sizeH
    },
    displaySize: {
      width: cropSize.width,
      height: cropSize.height
    }
  };
  return new Promise(function (resolve, reject) {
    return _reactNative.ImageEditor.cropImage(imageUri, cropData, resolve, reject);
  });
};

exports.default = _default;